VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form slam 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "SLAM: (platform: ER-1; sensor: SICK LMS)"
   ClientHeight    =   7335
   ClientLeft      =   150
   ClientTop       =   435
   ClientWidth     =   9975
   BeginProperty Font 
      Name            =   "Fixedsys"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7335
   ScaleWidth      =   9975
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame1 
      Caption         =   "Telnet"
      Height          =   2775
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   9975
      Begin VB.TextBox ReceiveText 
         Height          =   330
         Left            =   2880
         TabIndex        =   13
         Top             =   2400
         Width           =   6615
      End
      Begin VB.TextBox SendText 
         Height          =   375
         Left            =   120
         TabIndex        =   11
         Top             =   2040
         Width           =   9375
      End
      Begin MSCommLib.MSComm MSComm1 
         Left            =   4320
         Top             =   1200
         _ExtentX        =   1005
         _ExtentY        =   1005
         _Version        =   393216
         DTREnable       =   -1  'True
      End
      Begin VB.Timer moveScanTimer 
         Enabled         =   0   'False
         Interval        =   500
         Left            =   2760
         Top             =   1200
      End
      Begin VB.TextBox ipAddress 
         Height          =   330
         Left            =   1440
         TabIndex        =   10
         Top             =   240
         Width           =   2175
      End
      Begin MSWinsockLib.Winsock Winsock1 
         Left            =   1440
         Top             =   1200
         _ExtentX        =   741
         _ExtentY        =   741
         _Version        =   393216
      End
      Begin VB.Timer Timer1 
         Enabled         =   0   'False
         Interval        =   1000
         Left            =   2160
         Top             =   1200
      End
      Begin VB.TextBox Text2 
         Height          =   975
         Left            =   5400
         Locked          =   -1  'True
         MultiLine       =   -1  'True
         ScrollBars      =   3  'Both
         TabIndex        =   6
         Top             =   240
         Width           =   4215
      End
      Begin VB.CommandButton disconnect 
         Caption         =   "&Disconnect"
         Height          =   375
         Left            =   3720
         TabIndex        =   5
         TabStop         =   0   'False
         Top             =   720
         Width           =   1575
      End
      Begin VB.CommandButton connect 
         Caption         =   "&Connect"
         Height          =   375
         Left            =   3720
         TabIndex        =   4
         TabStop         =   0   'False
         Top             =   240
         Width           =   1575
      End
      Begin VB.TextBox Port 
         Height          =   330
         Left            =   1440
         TabIndex        =   3
         Top             =   720
         Width           =   2175
      End
      Begin VB.Label Label5 
         Caption         =   "Data transmitted to SICK"
         Height          =   255
         Left            =   120
         TabIndex        =   12
         Top             =   1800
         Width           =   3135
      End
      Begin VB.Label Label4 
         Caption         =   "Terminal:"
         Height          =   255
         Left            =   120
         TabIndex        =   9
         Top             =   2520
         Width           =   1215
      End
      Begin VB.Label Label2 
         BackStyle       =   0  'Transparent
         Caption         =   "Port:"
         Height          =   255
         Left            =   120
         TabIndex        =   8
         Top             =   720
         Width           =   1095
      End
      Begin VB.Label Label1 
         BackStyle       =   0  'Transparent
         Caption         =   "Host name:"
         Height          =   255
         Left            =   120
         TabIndex        =   7
         Top             =   240
         Width           =   1455
      End
   End
   Begin VB.VScrollBar VScroll1 
      Height          =   4575
      Left            =   9720
      Max             =   25
      TabIndex        =   0
      Top             =   2760
      Width           =   256
   End
   Begin VB.Label Label3 
      BackColor       =   &H00000000&
      Height          =   4575
      Left            =   0
      TabIndex        =   1
      Top             =   2760
      Width           =   9615
   End
End
Attribute VB_Name = "slam"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'-------------------------------------------------------------------------------------------
' AUTH: B. Green
' DATE: 08/25/06
' DESC: The Visual Basic code integrates the ER1 Robot Control Center and
'       SICK laser scanner to:
'         -move ER1 forward 9 inches (experiment was done in room with 9" tiles)
'         -after move has completed, get position data from encoders
'         -execute a single scan of environment
'         -write position data and laser data to file
'         -loop again
'
'       Matlab can then be used to take the position and laser data and perform SLAM off-line
'---------------------------------------------------------------------------------------------
Option Explicit
'---Terminal Information
Dim counter, SendChar As Integer
Dim TotalText As String
'---Terminal Constants
Const BufferSize As Integer = 50
Const ScreenSize As Integer = 25
'---Host Information
Dim HostCount As Integer
Dim Host(20) As HostInfo
Private Type HostInfo
HostName As String
Port As Long
End Type
'---SICK LMS sensor variable
Public GatherData
Public BeginWrite1, BeginWrite2, BeginWrite3 As Boolean
Public ScanCount As Integer
'---Cursor Information
Dim CurPos, LastPos As Integer
Dim DeleteMode As Boolean
Dim CurShow As Boolean
Dim LastChar As String
'---Move Robot
Dim getPosition As String
Dim boundLength, distance As Integer
Dim X, Y, Phi As Integer
Dim mvCounter As Integer
Public newMove As Boolean
Dim moveDone As Boolean
'-----SLAM Variables (must declare only one matrix per line here)
Dim numStates, r, c As Integer
Dim xest_text As String
Dim xest(1 To 10, 1) As Double
Dim Pest(1 To 3, 1 To 3) As Double
Dim A(1 To 3, 1 To 3) As Double
Dim At(1 To 3, 1 To 3) As Double
Dim W(1 To 3, 1 To 3) As Double
Dim Wt(1 To 3, 1 To 3) As Double
Dim Q(1 To 3, 1 To 3) As Double
Dim result1() As Double
Dim result2() As Double
Dim result3() As Double


'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
'% Executed when program is first run
'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Private Sub Form_Load()

    moveScanTimer.Enabled = False

    '// ipAddress.Text = "192.168.1.101" 'home
    ipAddress.Text = "localhost" 'school
    Port = 9000
    
    '// Set terminal colours
    Label3.ForeColor = RGB(0, 170, 0)   'green text
    Label3.BackColor = RGB(0, 0, 0)     'black background
    
    '// Set object properties
    functions.EnableConnect
    
    '// Initialize move variables
    boundLength = 9 * 12    '// 9 foot boundary
    distance = 0            '// keep track of input
    mvCounter = 1
    
    '// Initialize SLAM variables
    X = 0
    Y = 0
    Phi = 0
    newMove = False '// set to start with laser scan
    moveDone = True '// set to start with laser scan
    numStates = 3
        
    Me.KeyPreview = True
    
    '// Initialize RS232 variables
    GatherData = False
    ScanCount = 1
    
    '// Initialize RS232 communication
    With MSComm1
       .InputMode = comInputModeBinary
       .CommPort = 6
       .InputLen = 0
       .Handshaking = 0 - comNone
       .RThreshold = 400
       .RTSEnable = False
       .Settings = "9600,N,8,1"
       .SThreshold = 8
       .PortOpen = True
       '// Leave all other settings as default values.
    End With
    
    '// Open files for saving data to
    Open "slamData.txt" For Output As #1
    Open "laserData.txt" For Output As #2

End Sub

'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
'% Connect to ER-1 Robot Control Center
'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Private Sub connect_Click()
    Dim StartTime As Date
    Dim HostNo As Integer
    Dim FoundHost As Boolean
    
    '// Set the communication properties
    Winsock1.LocalPort = 0
    Winsock1.RemoteHost = ipAddress.Text
    Winsock1.RemotePort = Port
    
    '// Add info to log
    functions.AddLog "Connecting to: " & ipAddress.Text & " Port " & Port & vbCrLf
    Winsock1.connect
    functions.AddLog "Connection."
    
    '// Reset time counter
    counter = 0
    
    '// Enable status check
    Timer1.Enabled = True
    
    '// Ping SICK LMS sensor to start communications
    SendText.Text = "&H02&H00&H02&H00&H20&H24&H34&H08"
    Call sick.Send
End Sub

'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
'% Disconnect from ER-1 Robot Control Center
'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Private Sub disconnect_Click()
    functions.CloseConnection
    
    '// Stop transmission with SICK sensor
    SendText.Text = "&H02&H00&H02&H00&H20&H25&H35&H08"
    Call sick.Send
    
    '// makes sure RS232 communication is closed when code is not running
    MSComm1.PortOpen = False
    
    '// Close data files
    Close #1
    Close #2
End Sub

'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
'% Timer used to check if move is finished...if so take a scan and loop again
'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Private Sub moveScanTimer_Timer()
    
    Winsock1.SendData "events" + vbCrLf
    
    If newMove = True Then
        Call moveRobot '// function to move robot around 9x9 grid
        newMove = False
    End If
        
    
    '// ER1 RCC returns "move done" when move is finished
    If moveDone = True Then
        '// get position data from ER-1 encoders
        getPosition = "position" + Chr(13)
        Winsock1.SendData getPosition + vbCrLf
        
        '// grab laser scan
        GatherData = True
        ScanCount = 1
        BeginWrite1 = False
        BeginWrite2 = False
        BeginWrite3 = False
        
        Call slam(X, Y, Phi)
        
        '// reset variable
        moveDone = False
        
    End If
    
End Sub

'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
'% Saves a single laser scan (361 data pts) to laserdata.txt
'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Private Sub MSComm1_OnComm()
    sick.saveScan
End Sub

'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
'% Loop is executed once a second
'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Private Sub Timer1_Timer()
    '// Wait for host to be resolved
    
    '// Inc Count
    counter = counter + 1
    functions.AddLog "."
    
    '// Client waiting to long, host not resolved
    If counter >= 10 Then
    Winsock1.Close
    functions.AddLog "Failed" & vbCrLf
    MousePointer = 0
    Timer1.Enabled = False
    End If
    
End Sub

'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
'% Loop is executed when vertical slider is moved
'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Private Sub VScroll1_Change()
    '// Updates the label view according to slider control
    
    Dim CurrentText As String
    Dim CRFound As Integer
    Dim Pos1 As Integer
    Dim Pos2 As Integer
    Dim A As Integer
    With Label3
    
    'Initial variables
    CurrentText = TotalText
    Pos1 = Len(CurrentText)
    Pos2 = 1
    CRFound = 0
    
    'Look for LFs
    For A = Len(CurrentText) - 1 To 1 Step -1
    If Mid(CurrentText, A, 1) = vbLf Then 'Found LF
    CRFound = CRFound + 1 'Inc number of LFs found
    If CRFound = VScroll1.Max - VScroll1.Value Then Pos1 = A + 1
    If CRFound = (VScroll1.Max - VScroll1.Value) + ScreenSize Then
    Pos2 = A + 1
    End If
    End If
    Next
    
    '// Set new current label
    CurrentText = Mid(CurrentText, Pos2, (Pos1 - Pos2) + 1)
    Label3 = CurrentText
    End With
    
End Sub

Private Sub Winsock1_Connect()
    '// Socket has connected with host
    functions.AddLog "Successful" & vbCrLf
    
    '// Disable timer
    Timer1.Enabled = False
    moveScanTimer.Enabled = True
            
    '// Clear text box
    Label3.Caption = ""
    TotalText = Empty
    DeleteMode = False
    '// Disable connect button
    functions.DisableConnect
    
    '// Restore mouse
    MousePointer = 0
    
    '// Send beginning message
    Winsock1.SendData Chr(255) & Chr(251) & Chr(24) & vbCrLf
    
End Sub

Private Sub Winsock1_Close()
    functions.CloseConnection
End Sub

'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Private Sub Form_KeyPress(KeyAscii As Integer)
    '// Send Text if connected
    If Winsock1.State = 7 Then
        If KeyAscii = 13 Then
            Winsock1.SendData vbCrLf
            Text2.Text = ""
        Else
            SendChar = KeyAscii
            Winsock1.SendData Chr(SendChar)
            Text2.Text = Text2.Text + Chr(SendChar)
        End If
        
    End If
End Sub

Private Sub Winsock1_DataArrival(ByVal bytesTotal As Long)
    Dim SockText As String
    Dim NewText As String
    Dim CRFound As Integer
    Dim LeftPos As Integer
    Dim A As Long
    Dim x_y_phi As String
    Dim firstBlank, secondBlank, thirdBlank As Integer
    
    
    Winsock1.GetData SockText, vbString
    
    '// Disable delete mode if no text is returned
    If SockText = "" Then
        DeleteMode = False
        Exit Sub
    End If
    
    Text2.Text = ""
    
    If Left(SockText, 9) = "move done" Then
        moveDone = True
    ElseIf (Len(SockText) > 10) Then
        '// Get robot's current position
        x_y_phi = SockText
        
        '// Get x value
        firstBlank = InStr(x_y_phi, " ")
        x_y_phi = Right(x_y_phi, Len(x_y_phi) - firstBlank) '// take part after text
        secondBlank = InStr(x_y_phi, " ")
        X = Val(Left(x_y_phi, secondBlank)) '// extract X position
        
        '// Get y value
        x_y_phi = Right(x_y_phi, Len(x_y_phi) - secondBlank)
        thirdBlank = InStr(x_y_phi, " ")
        Y = Val(Left(x_y_phi, thirdBlank))  '// extract Y position
    
        '// Get Phi (encoders are not returning Phi so instead
        '// must sum up based on input (see move_timer)
        '// Phi = Val(Right(x_y_phi, Len(x_y_phi) - thirdBlank))
        
    End If
    
    Text2.Text = Phi
    
    SockText = functions.FindEscapeSeq(SockText)
    '// Strip out unwanted characters
    NewText = Empty
    For A = 1 To Len(SockText)
    Select Case Asc(Mid(SockText, A, 1))
    Case 7 '// Beep char
    Beep
    Case 0 To 9, 11 To 31, 128 To 255 '// Unprintable control chars
    Case Else
    NewText = NewText + Mid(SockText, A, 1) '// Wanted chars
    End Select
    Next
    SockText = NewText
    
    '// Calculates the invisible cursor position after BS has been pressed
    If SendChar = 8 Then
    DeleteMode = True
    If Len(TotalText) > 0 Then
    For A = 1 To Len(TotalText)
    If Mid(TotalText, A, 1) = vbLf Then
    CurPos = A + Len(SockText)
    End If
    Next
    End If
    Exit Sub
    ElseIf SendChar = 13 Then
    DeleteMode = False
    End If
    '// Adds incoming text to Buffered Text variable at correct pos
    If DeleteMode = False Then
    TotalText = TotalText & SockText
    Else
    CurPos = CurPos + 1
    Mid(TotalText, CurPos, 1) = SockText
    If CurPos = Len(TotalText) Then DeleteMode = False
    End If
    
    '// Ensures buffer zone is kept retaining BufferSize Number of lines
    If Len(TotalText) > 0 Then
    LeftPos = 0
    CRFound = 0
    For A = Len(TotalText) To 1 Step -1
    If Mid(TotalText, A, 1) = vbLf Then
    CRFound = CRFound + 1
    If CRFound = BufferSize + 1 Then
    LeftPos = A
    End If
    End If
    Next
    End If
    TotalText = Right(TotalText, Len(TotalText) - LeftPos)
    
    '// Sets slider properties and updates caption
    With VScroll1
    If CRFound > ScreenSize Then
    If LeftPos > 0 Then
    .Max = BufferSize - ScreenSize
    Else
    .Max = CRFound - ScreenSize
    End If
    .Enabled = True
    .Value = .Max
    VScroll1_Change
    Else
    Label3.Caption = TotalText
    End If
    End With
    
End Sub
Private Sub Winsock1_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    '// Display Winsock Error
    MsgBox "A Winsock Error has occurred. Error No. " & Number & " " & Description
End Sub

'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
'% Originally, this function was created to do SLAM in real time, but I never got
'% around to finishing it.  As of now, it just writes the encoder data to file
'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Sub slam(ByVal xRobot As Double, ByVal yRobot As Double, ByVal phiRobot As Double)

    Dim delX, delY As Double
    Dim i, j As Integer
    
    '// Calculate delX and delY for Jacobian A
    delX = xRobot - xest(1, 1) '// current - previous x-location
    delY = yRobot - xest(2, 1) '// current - previous y-location
        
    '// ER-1 gives you x,y,phi position based on encoders
    '// Therefore, the model used in the prediction step simplifies to
    xest(1, 1) = xRobot
    xest(2, 1) = yRobot
    xest(3, 1) = phiRobot
    
    '// Landmarks are assumed to be static, i.e. pi(k) = pi(k-1)
    If numStates > 3 Then
        For i = 4 To numStates
            xest(i, 1) = xest(i, 1)
        Next i
    End If
    
    '// Calculate Jacobian A based on vehicle model (df/dx)
    A(1, 1) = 1
    A(1, 2) = 0
    A(1, 3) = -delY
    A(2, 1) = 0
    A(2, 2) = 1
    A(2, 3) = delX
    A(3, 1) = 0
    A(3, 2) = 0
    A(3, 3) = 1
    '// Rest of A (which is just 2 null matrices and 1 identity) is added in new_state function
    
    '// Set At,Wt equal to A,W and then pass to transpose function -> otherwise, A,W will be transposed
    For r = 1 To numStates
        For c = 1 To numStates
            At(r, c) = A(r, c)
            Wt(r, c) = W(r, c)
        Next
    Next
    
    '// Calculate prediction for covariance matrix
    Call functions.transpose(At)                    '// transpose matrix A & store as At
    Call functions.transpose(Wt)                    '// transpose matrix W & store as Wt
    Call functions.multiply(A, Pest, result1)       '// result1 = A*Pest
    Call functions.multiply(result1, At, result2)   '// result2 = A*Pest*A'
    Call functions.multiply(W, Q, result1)          '// result1 = W*Q
    Call functions.multiply(result1, Wt, result3)   '// result3 = W*Q*W'
    Call functions.add(result2, result3, result1)   '// result1 = result2 + result3
    'Pest = result1                                  '// Pest = A*Pest*A' + W*Q*W'
    
    '// Check to see if new position data is available
    
    '// Check to see if new laser data is available
    
    '// Write xest to file
    For j = 1 To numStates
        If j = 1 Then
            xest_text = xest(j, 1)
        Else
            xest_text = xest_text & "," & xest(j, 1)
        End If
    Next
    
    Print #1, xest_text
    xest_text = ""
End Sub


'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
'% Moves ER-1 around so it can observe landmarks & build map
'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Sub moveRobot()

    If mvCounter = 1 Then
        Winsock1.SendData "move 9 inches" + Chr(13) + vbCrLf
        distance = distance + 9
        If distance > (boundLength) Then
            mvCounter = mvCounter + 1
            distance = 0
        End If
    ElseIf mvCounter = 2 Then
        Winsock1.SendData "move 90 degrees" + Chr(13) + vbCrLf
        mvCounter = mvCounter + 1
    ElseIf mvCounter = 3 Then
        Phi = 90 '// update Phi after move has been completed
        Winsock1.SendData "move 9 inches" + Chr(13) + vbCrLf
        distance = distance + 9
        If distance > (boundLength) Then
            mvCounter = mvCounter + 1
            distance = 0
        End If
    ElseIf mvCounter = 4 Then
        Winsock1.SendData "move 90 degrees" + Chr(13) + vbCrLf
        mvCounter = mvCounter + 1
    ElseIf mvCounter = 5 Then
        Phi = 180 '// update Phi after move has been completed
        Winsock1.SendData "move 9 inches" + Chr(13) + vbCrLf
        distance = distance + 9
        If distance > (boundLength) Then
            mvCounter = mvCounter + 1
            distance = 0
        End If
    ElseIf mvCounter = 6 Then
        Winsock1.SendData "move 90 degrees" + Chr(13) + vbCrLf
        mvCounter = mvCounter + 1
    ElseIf mvCounter = 7 Then
        Phi = 270 '// update Phi after move has been completed
        Winsock1.SendData "move 9 inches" + Chr(13) + vbCrLf
        distance = distance + 9
        If distance > (boundLength) Then
            mvCounter = mvCounter + 1
            distance = 0
        End If
    End If
End Sub
